
# AlgTools

Author: Tuomo Valkonen <tuomov@iki.fi>

**This crate is very much incomplete.**

This crate/repository/package contains some general utility routines and tools for implementing
iterative algorithms and numerical computing in Rust. Former versions of the package were for Julia.
They are no longer mintained. Included are:

  * [Linear operator](crate::linops) abstraction, with support for matrices via `nalgebra`
    or `ndarray` if this crate is compiled with the relevant features.
  * [Iteration mechanism](crate::iterate) for generically implementing intermittent verbosity and stopping rules in algorithms.
  * The iterators can employ a [logger](crate::logger) to store the intermittent results
    (e.g. function values) in memory to later write into a `csv`-file.
  * [Bisection trees](crate::bisection_tree) for branch-and-bound optimisation.

<!--The code is used by [ImageTools][] and both, for example, by :
-->

## Installation

???
